<?php

namespace FiloBlu\Job\Block\Adminhtml\System\Config\Form\Field;

use Magento\Backend\Block\Template\Context;
use Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray;
use Magento\Directory\Model\ResourceModel\Country\CollectionFactory;
use Magento\Framework\View\Element\Html\Select;

/**
 * Class Departments
 * @package FiloBlu\Job\Block\Adminhtml\System\Config\Form\Field
 */
class Departments extends AbstractFieldArray
{

    /**
     * @var FiloBlu\Job\Block\Adminhtml\System\Config\Form\Field\Country
     */
    protected $_countryCollectionFactory;

    /**
     * Form constructor.
     * @param CollectionFactory $countryCollectionFactory
     * @param Context $context
     * @param array $data
     */
    public function __construct(
        CollectionFactory $countryCollectionFactory,
        Context $context,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->_countryCollectionFactory = $countryCollectionFactory;
    }

    /**
     * Prepare to render
     * @return void
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    protected function _prepareToRender()
    {
        $countryBlock = $this->getLayout()
            ->createBlock(Select::class)
            ->setId($this->_getCellInputElementId('<%- _id %>', 'country'))
            ->setName($this->_getCellInputElementName('country'))
            ->setClass('select')
            ->setOptions($this->_countryCollectionFactory->create()->loadByStore()->toOptionArray());

        $this->addColumn('department', [
            'label' => __('Department'),
            'renderer' => 'textarea']);

        $this->addColumn(
            'country',
            [
                'label' => __('Country'),
                'renderer' => $countryBlock]
        );

        $this->_addAfter = false;
        $this->_addButtonLabel = __('Add New');
    }
}
